SystemOrganization addCategory: #'EjerciciosPoo-TusLibros'!

Error subclass: #CanNotAddABookFromOtherEditorialToACart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

Object subclass: #Book
	instanceVariableNames: 'editorial isbn price'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Book class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 17:00'!
newWithIsbn: anIsbn price: aPrice

	^Book new initializeWithIsbn: anIsbn price: aPrice! !

!Book methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 17:02'!
initializeWithIsbn: anIsbn price: aPrice

	isbn := anIsbn.
	price := aPrice.! !

!Book methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 17:03'!
isbn
	
	^isbn! !

!Book methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 17:04'!
price
	
	^price! !

Object subclass: #Cart
	instanceVariableNames: 'acceptedBooks contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/11/2012 18:46'!
newWithListOfAcceptedBooks: aListOfAcceptedBooks
	
	^self new initializeWithListOfAcceptedBooks: aListOfAcceptedBooks! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 17:03'!
add: aBook
	
	(acceptedBooks includes: aBook isbn) 
		ifTrue: [contents add: aBook]
		ifFalse: [CanNotAddABookFromOtherEditorialToACart signal: 'No se puede agregar un libro de otra editorial']! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/11/2012 18:47'!
initializeWithListOfAcceptedBooks: aListOfAcceptedBooks

	acceptedBooks := aListOfAcceptedBooks.
	contents := Bag new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/11/2012 18:55'!
isEmpty 
	
	^contents isEmpty ! !

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TusLibrosTest methodsFor: 'books' stamp: 'IgalFrid 6/13/2012 17:02'!
bookFromEditorial1 

	^Book newWithIsbn:'Book10' price: 3! !

!TusLibrosTest methodsFor: 'books' stamp: 'IgalFrid 6/13/2012 17:03'!
bookFromEditorial2 

	^Book newWithIsbn:'Book20' price: 3! !

!TusLibrosTest methodsFor: 'errors' stamp: 'IgalFrid 6/8/2012 17:45'!
canNotAddABookFromOtherEditorialToACart
	
	^CanNotAddABookFromOtherEditorialToACart! !

!TusLibrosTest methodsFor: 'carts' stamp: 'IgalFrid 6/11/2012 18:54'!
cartFromEditorial1 
	
	^Cart newWithListOfAcceptedBooks: self listOfBooks1.! !

!TusLibrosTest methodsFor: 'carts' stamp: 'IgalFrid 6/11/2012 18:54'!
cartFromEditorial2 
	
	^Cart newWithListOfAcceptedBooks: self listOfBooks2.! !

!TusLibrosTest methodsFor: 'books' stamp: 'IgalFrid 6/11/2012 18:54'!
listOfBooks1

	^#('Book10', 'Book11')! !

!TusLibrosTest methodsFor: 'books' stamp: 'IgalFrid 6/11/2012 18:54'!
listOfBooks2

	^#('Book20', 'Book21', 'Book22')! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/8/2012 17:07'!
test01NewCartShouldBeEmpty

	self assert: self cartFromEditorial1 isEmpty! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/8/2012 17:02'!
test02CanAddABookFromTheSameEditorialOfTheCart

	| cart |
	
	cart := self cartFromEditorial1.
	cart add: self bookFromEditorial1.
	self deny: cart isEmpty! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/8/2012 17:44'!
test03CannotAddABookFromOtherEditorialToACart

	| cart |
	
	cart := self cartFromEditorial1.
	self should: [ self cartFromEditorial1 add: self bookFromEditorial2] raise: self canNotAddABookFromOtherEditorialToACart.! !
